/*CVAR SCRIPT BY MRCLONE | ABSOLUTE CVAR CONTROL, v0.5, 08.12.02
That script controls cvars with shortcuts.
For example: "admin_cv ff 1" does the same like "admin_friendlyfire 1" or "mp_friendlyfire 1".
If you type "admin_cv ff" only, the script will show you the data of "mp_friendlyfire" 
and help for valid values <- very useful! :-)
*/
#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

// This are the needed Access Levels
#define CVAR_ACCESS 0
#define LOW 32
#define MEDIUM 128
#define HIGH 512

new CVARFILE[MAX_TEXT_LENGTH];
new CVARLANG[MAX_TEXT_LENGTH];
new Command[MAX_COMMAND_LENGTH];
new Data[MAX_DATA_LENGTH];
new User[MAX_NAME_LENGTH];
new k;
new slog[200];
new acc1 = 0;
new acc2 = 0;
new acc3 = 0;
cvar_data(sAccess[ ],sHLCmd[ ],sData[200],sValue[ ]) {
	new bool4 = 0;
	if (streq(sAccess,"L")==1) {
		if (acc1 == 1 ) {
			bool4 = 2;
		} else {
			if(streq(CVARLANG,"1")==1)
				snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: Du benoetigst 'LOW' Rechte fuer %s",sHLCmd);
			else
				snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: You need 'LOW' access for %s",sHLCmd);
			selfmessage(slog);
			bool4 = 0;
		}
	}
	else if (streq(sAccess,"M")==1) {
		if (acc2 == 1 ) {
			bool4 = 2;
		} else {
			if(streq(CVARLANG,"1")==1)
				snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: Du benoetigst 'MEDIUM' Rechte fuer %s",sHLCmd);
			else
				snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: You need 'MEDIUM' access for %s",sHLCmd);
			selfmessage(slog);
			bool4 = 0;
		}
	}
	else if (streq(sAccess,"H")==1) {
		if (acc3 == 1 ) {
			bool4 = 2;
		} else {
			if(streq(CVARLANG,"1")==1)
				snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: Du benoetigst 'HIGH' Rechte fuer %s",sHLCmd);
			else
				snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: You need 'HIGH' access for %s",sHLCmd);
			selfmessage(slog);
			bool4 = 0;
		}
	}
	else {
		if(streq(CVARLANG,"1")==1)
			snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: Fehler in ^'%s^', Zeile ^'%d^', kein oder falsches Recht vorhanden.",CVARFILE,k);
		else
			snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: error in ^'%s^', line ^'%d^', no or wrong access given",CVARFILE,k);
		selfmessage(slog);
		log(slog);
		bool4 = 0;
	}

	if ( bool4 != 0 )
	{
		if (strlen(sHLCmd) < 3) {
			if(streq(CVARLANG,"1")==1)
				snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: Fehler in ^'%s^', Zeile ^'%d^', kein Befehl angegeben",CVARFILE,k);
			else
				snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: error in ^'%s^', line ^'%d^', no cvar given",CVARFILE,k);
			selfmessage(slog);
			log(slog);
		} else {
			new GetCvar[MAX_DATA_LENGTH];
			getstrvar(sHLCmd,GetCvar,MAX_DATA_LENGTH);
			if (strlen(GetCvar)==0) {
				if(streq(CVARLANG,"1")==1)
					snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: Fehler in ^'%s^', Zeile ^'%d^', Befehl ist nicht gueltig: ^'%s^'",CVARFILE,k,sHLCmd);
				else
					snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: error in ^'%s^', line ^'%d^', given cvar is not valid: ^'%s^'",CVARFILE,k,sHLCmd);
				selfmessage(slog);
				log(slog);
			} else {
				if (strlen(sData) > 0) {
					new sOut[200] = 0;
					new sSplitData[2][100];
					strsplit(sData," ",sSplitData[0],60,sSplitData[1],60);
					if ( streq(sSplitData[0],"+")==1 ) {
						numtostr(getvar(sHLCmd)+strtonum(sSplitData[1]),sOut);
					} else if ( streq(sSplitData[0],"-")==1 ) {
						numtostr(getvar(sHLCmd)-strtonum(sSplitData[1]),sOut);
					} else {
						sOut = sData;
					}
					if (streq(GetCvar,sOut) != 1) {
						new sExec[MAX_DATA_LENGTH];
						snprintf(sExec,100,"%s ^"%s^"",sHLCmd,sOut);
						exec(sExec);
						//setstrvar(sHLCmd,sOut); //This line works only with AdminMod newer than v25026
						if(streq(CVARLANG,"1")==1)
							snprintf(slog,MAX_TEXT_LENGTH,"%s benutzte: ^"%s %s^" fuer ^"%s = %s^"",User,Command,Data,sHLCmd,sOut);
						else
							snprintf(slog,MAX_TEXT_LENGTH,"%s used command: ^"%s %s^" for ^"%s = %s^"",User,Command,Data,sHLCmd,sOut);
						if (getvar("admin_quiet")==0) {
							//server logs command with "say()"
							say(slog);
						} else {
							log(slog);
							selfmessage(slog);
						}
					} else {
						if(streq(CVARLANG,"1")==1)
							snprintf(slog, MAX_TEXT_LENGTH, "plugin_mc_cvar: %s ist bereits %s  |  gueltige Werte sind %s",sHLCmd,GetCvar,sValue);
						else
							snprintf(slog, MAX_TEXT_LENGTH, "plugin_mc_cvar: %s is already %s  |  valid values are %s",sHLCmd,GetCvar,sValue);
						selfmessage(slog);
					}
				} else {
					if (strlen(sValue) == 0) {
						if(streq(CVARLANG,"1")==1)
							snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: Warnung in ^'%s^', keine Beschreibung in Zeile ^'%d^', ^'%s^'",CVARFILE,k,sHLCmd);
						else
							snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: warning in ^'%s^', no description in line ^'%d^', ^'%s^'",CVARFILE,k,sHLCmd);
						selfmessage(slog);
						log(slog);
					}
					if(streq(CVARLANG,"1")==1)
						snprintf(slog, MAX_TEXT_LENGTH, "plugin_mc_cvar: %s ist %s  |  gueltige Werte sind %s",sHLCmd,GetCvar,sValue);
					else
						snprintf(slog, MAX_TEXT_LENGTH, "plugin_mc_cvar: %s is %s  |  valid values are %s",sHLCmd,GetCvar,sValue);
					selfmessage(slog);
				}
			}
		}
	}
	return 1;
}
public admin_cv(HLCommand,HLData,HLUserName,UserIndex) {
	new Data2[MAX_DATA_LENGTH];
	new Data3[MAX_DATA_LENGTH];
	new sLine[MAX_DATA_LENGTH];
	new HLlin[4][30];
	new bool = 0;
	new bool2 = 0;
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	if (access(HIGH,User)==1)
		acc3 = 1;
	if (access(MEDIUM,User)==1)
		acc2 = 1;
	if (access(LOW,User)==1)
		acc1 = 1;

	if(strlen(Data) > 0) {
		strbreak(Data,Data2,Data3,MAX_DATA_LENGTH);
		if(fileexists(CVARFILE)) {
			if (getvar("file_access_read") == 1) {
				if(strcasecmp(Data,"help")==0) {
					for(k=1 ; k<=50 ; k++){
						if(readfile(CVARFILE,sLine,k,100) != 0) {
							if(strncmp(sLine,";",1) != 0) {
								selfmessage(sLine);
								bool = 1;
								bool2 = 1;
							}
						}
					}
				} else {
					for(k=1 ; k<=40 ; k++) {
						if(readfile(CVARFILE,sLine,k,100) != 0) {
							if(strncmp(sLine,";",1) != 0) {
								strsplit(sLine," ",HLlin[0],4,HLlin[1],30,HLlin[2],40,HLlin[3],30);
								if(streq(Data2,HLlin[1])==1 || streq(Data2,HLlin[2])==1) {
									cvar_data(HLlin[0],HLlin[2],Data3,HLlin[3]);
									bool = 1;
								}
							}
						}
					}
				}
			} else {
				if(streq(CVARLANG,"1")==1)
					selfmessage("plugin_mc_cvar: Fehler, ^'file_access_read^' muss aktiviert sein");
				else
					selfmessage("plugin_mc_cvar: error, ^'file_access_read^' must be activated");
				bool = 1;
			}
		} else {
			if(streq(CVARLANG,"1")==1)
				snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: Fehler, %s existiert nicht, oder Wert ^'CVAR_FILE^' in der vault Datei ist falsch",CVARFILE);
			else
				snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: error, %s does not exist, or value of ^'CVAR_FILE^' in vault file is wrong",CVARFILE);
			selfmessage(slog);
			log(slog);
			bool = 1;
		}
	} else {
		if(streq(CVARLANG,"1")==1)
			selfmessage("plugin_mc_cvar: Bitte geben Sie ein gueltiges Kuerzel oder admin_cv help ein.");
		else
			selfmessage("plugin_mc_cvar: Please type a valid cvar-shortcut and value, or type admin_cv help.");
		bool = 1;
	}
	if (bool == 0) {
		if(streq(CVARLANG,"1")==1)
			snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: Warnung, %s ist kein gueltiges Kuerzel und kein glueltiger Befehl",Data2);
		else
			snprintf(slog,MAX_TEXT_LENGTH,"plugin_mc_cvar: warning, %s is not a valid cvar-shortcut",Data2);
		selfmessage(slog);
	}
	if (bool2 == 1) {
		if (acc1==1)
			if(streq(CVARLANG,"1")==1)
				selfmessage("Du hast 'LOW' Rechte (L).");
			else
				selfmessage("You have 'LOW' access (L).");
		else
			if(streq(CVARLANG,"1")==1)
				selfmessage("! Du hast keine 'LOW' Rechte (L).");
			else
				selfmessage("! You have not 'LOW' access (L).");

		if (acc2==1)
			if(streq(CVARLANG,"1")==1)
				selfmessage("Du hast 'MEDIUM' Rechte (M).");
			else
				selfmessage("You have 'MEDIUM' access (M).");
		else
			if(streq(CVARLANG,"1")==1)
				selfmessage("! Du hast keine 'MEDIUM' Rechte (M).");
			else
				selfmessage("! You have not 'MEDIUM' access (M).");

		if (acc3==1)
			if(streq(CVARLANG,"1")==1)
				selfmessage("Du hast 'HIGH' Rechte (H).");
			else
				selfmessage("You have 'HIGH' access (H).");
		else
			if(streq(CVARLANG,"1")==1)
				selfmessage("! Du hast keine 'HIGH' Rechte (H).");
			else
				selfmessage("! You have not 'HIGH' access (H).");
	}
	return PLUGIN_HANDLED;
}

public plugin_init() {
	get_vaultdata("CVAR_FILE",CVARFILE,MAX_DATA_LENGTH);
	get_vaultdata("CVAR_LANGUAGE",CVARLANG,MAX_DATA_LENGTH);
	if(strlen(CVARFILE)==0){
		set_vaultdata("CVAR_FILE","commands.cfg");
		get_vaultdata("CVAR_FILE",CVARFILE,MAX_DATA_LENGTH);
	}
	if(strlen(CVARLANG)==0){
		set_vaultdata("CVAR_LANGUAGE","1");
		get_vaultdata("CVAR_LANGUAGE",CVARLANG,MAX_DATA_LENGTH);
	}
	if(streq(CVARLANG,"1")==1)
		plugin_registercmd("admin_cv","admin_cv",CVAR_ACCESS,"admin_cv <Befehl/Kuerzel> <<+/-> Wert>: Steuert Befehle ueber Befehlskuerzel");
	else
		plugin_registercmd("admin_cv","admin_cv",CVAR_ACCESS,"admin_cv <command/shortcut> <<+/-> Wert>: Controls commands with shortcuts");
	return PLUGIN_CONTINUE;
}